Package net.sf.saxon.functions

## Class FunctionLibraryList

- java.lang.Object
- - net.sf.saxon.functions.FunctionLibraryList

- All Implemented Interfaces:
    `FunctionLibrary`, `XQueryFunctionBinder`

      public class FunctionLibraryList
      extends java.lang.Object
      implements FunctionLibrary, XQueryFunctionBinder

  A FunctionLibraryList is a list of FunctionLibraries. It is also a FunctionLibrary in its own right. When required, it searches the list of FunctionLibraries to find the required function.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `java.util.List<FunctionLibrary>` | `libraryList` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FunctionLibraryList()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `addFunctionLibrary​(FunctionLibrary lib)` | Add a new FunctionLibrary to the list of FunctionLibraries in this FunctionLibraryList.
    `Expression` | `bind​(SymbolicName.F functionName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `FunctionLibrary` | `get​(int n)` | Get the n'th function library in the list
    `XQueryFunction` | `getDeclaration​(StructuredQName functionName, int staticArgs)` | Get the function declaration corresponding to a given function name and arity
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `java.util.List<FunctionLibrary>` | `getLibraryList()` | Get the list of contained FunctionLibraries.
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Field Detail

    - #### libraryList

          public java.util.List<FunctionLibrary> libraryList

  - ### Constructor Detail

    - #### FunctionLibraryList

          public FunctionLibraryList()

  - ### Method Detail

    - #### addFunctionLibrary

          public int addFunctionLibrary​(FunctionLibrary lib)

      Add a new FunctionLibrary to the list of FunctionLibraries in this FunctionLibraryList. Note that libraries are searched in the order they are added to the list.
      Parameters:
        `lib` - A function library to be added to the list of function libraries to be searched.
      Returns:
        the position of the library in the list

    - #### get

          public FunctionLibrary get​(int n)

      Get the n'th function library in the list

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
      Returns:
        true if a function of this name and arity is available for calling

    - #### bind

          public Expression bind​(SymbolicName.F functionName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - The name of the function
        `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.
        `env` - The static context
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.

    - #### getDeclaration

          public XQueryFunction getDeclaration​(StructuredQName functionName,
                                               int staticArgs)

      Get the function declaration corresponding to a given function name and arity
      Specified by:
        `getDeclaration` in interface `XQueryFunctionBinder`
      Parameters:
        `functionName` - the name of the function as a QName
        `staticArgs` - the number of expressions supplied as arguments in the function call
      Returns:
        the XQueryFunction if there is one, or null if not.

    - #### getLibraryList

          public java.util.List<FunctionLibrary> getLibraryList()

      Get the list of contained FunctionLibraries. This method allows the caller to modify the library list, for example by adding a new FunctionLibrary at a chosen position, by removing a library from the list, or by changing the order of libraries in the list. Note that such changes may violate rules in the language specifications, or assumptions made within the product.
      Returns:
        a list whose members are of class FunctionLibrary

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.